vsg: vsg::RenderGraph Class Reference

vsg 1.1.10 VulkanSceneGraph library |

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Public Attributes | Static Public Attributes | List of all members
vsg::RenderGraph Class Reference

`#include <RenderGraph.h>`

Inheritance diagram for vsg::RenderGraph:
[legend]
Collaboration diagram for vsg::RenderGraph:
[legend]

## Public Types
using | ClearValues = std::vector<VkClearValue>
| Buffer clearing settings for VkRenderPassBeginInfo.clearValueCount & VkRenderPassBeginInfo.pClearValues passed to the vkCmdBeginRenderPass.
Public Types inherited from vsg::Group
using | Children = std::vector<ref_ptr<Node>, allocator_affinity_nodes<ref_ptr<Node>>>

## Public Member Functions
| RenderGraph (ref_ptr< Window > in_window, ref_ptr< View > view={})
| Construct RenderGraph assigning window and setting up clearValues with the appropriate settings for the Window's attachments and color.
void | accept (RecordTraversal &recordTraversal) const override
| execute vkCmdBeginRenderPass and then traverse the RenderGraph subgraph
RenderPass * | getRenderPass ()
| RenderPass to use passed to the vkCmdBeginRenderPass, if renderPass is set it takes precedence, if not then either obtained from which of the framebuffer or window are active.
VkExtent2D | getExtent () const
| Get the Extent2D of the attached Framebuffer or Window.
void | setClearValues (VkClearColorValue clearColor={{0.2f, 0.2f, 0.4f, 1.0f}}, VkClearDepthStencilValue clearDepthStencil={0.0f, 0})
void | resized ()
| invoke the WindowResizeHandler, called automatically when a window dimension change is detected.
Public Member Functions inherited from vsg::Inherit< Group, RenderGraph >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
void | accept (ConstVisitor &visitor) const override
Public Member Functions inherited from vsg::Group
| Group (size_t numChildren=0)
| Group (const Group &rhs, const CopyOp &copyop={})
template<typename Iterator>
| Group (Iterator begin, Iterator end)
void | addChild (vsg::ref_ptr< Node > child)
ref_ptr< Object > | clone (const CopyOp &copyop={}) const override
void | traverse (Visitor &visitor) override
void | traverse (ConstVisitor &visitor) const override
void | traverse (RecordTraversal &visitor) const override
void | read (Input &input) override
void | write (Output &output) const override
Public Member Functions inherited from vsg::Inherit< Node, Group >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
void | accept (ConstVisitor &visitor) const override
Public Member Functions inherited from vsg::Node
| Node (const Node &rhs, const CopyOp &copyop={})
ref_ptr< Object > | clone (const CopyOp &copyop={}) const override
Public Member Functions inherited from vsg::Inherit< Object, Node >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
void | accept (ConstVisitor &visitor) const override
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T>
T * | cast ()
template<class T>
const T * | cast () const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T>
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T>
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Public Attributes
ref_ptr< Framebuffer > | framebuffer
| either window or framebuffer must be assigned. If framebuffer is set then it takes precedence, if not the appropriate window's framebuffer is used.
ref_ptr< Window > | window
VkRect2D | renderArea
| RenderArea settings for VkRenderPassBeginInfo.renderArea passed to the vkCmdBeginRenderPass, usually matches the ViewportState's scissor.
ref_ptr< RenderPass > | renderPass
| RenderPass to use passed to the vkCmdBeginRenderPass in place of the framebuffer's or window's renderPass. renderPass must be compatible with the render pass used to create the window or framebuffer.
ClearValues | clearValues
VkSubpassContents | contents = VK_SUBPASS_CONTENTS_INLINE
| Subpass contents setting passed to vkCmdBeginRenderPass.
ref_ptr< WindowResizeHandler > | windowResizeHandler
VkExtent2D | previous_extent = VkExtent2D{invalid_dimension, invalid_dimension}
Public Attributes inherited from vsg::Group
Children | children

## Static Public Attributes
static constexpr uint32_t | invalid_dimension = std::numeric_limits<uint32_t>::max()
| window extent at previous frame, used to track window resizes

## Additional Inherited Members
Static Public Member Functions inherited from vsg::Inherit< Group, RenderGraph >
static ref_ptr< RenderGraph > | create (Args &&... args)
static ref_ptr< RenderGraph > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Group
template<class N, class V>
static void | t_traverse (N &node, V &visitor)
Static Public Member Functions inherited from vsg::Inherit< Node, Group >
static ref_ptr< Group > | create (Args &&... args)
static ref_ptr< Group > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Node
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_NODES_OBJECTS
static void | operator delete (void *ptr)
Static Public Member Functions inherited from vsg::Inherit< Object, Node >
static ref_ptr< Node > | create (Args &&... args)
static ref_ptr< Node > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Detailed Description

RenderGraph encapsulates the vkCmdBeginRenderPass/vkCmdEndRenderPass functionality. Member variables of the RenderGraph map to the settings of the VkRenderPassBeginInfo. During the RecordTraversal children of RenderGraph are visited within the vkCmdBeginRenderPass/vkCmdEndRenderPass pair.

## Member Function Documentation

## ◆ accept()

void vsg::RenderGraph::accept | ( | RecordTraversal & | recordTraversal | ) | const
| overridevirtual

execute vkCmdBeginRenderPass and then traverse the RenderGraph subgraph

Reimplemented from vsg::Inherit< Group, RenderGraph >.

## ◆ setClearValues()

void vsg::RenderGraph::setClearValues | ( | VkClearColorValue | clearColor = {{0.2f, 0.2f, 0.4f, 1.0f}},
|  | VkClearDepthStencilValue | clearDepthStencil = {0.0f, 0} )

initialize clearValues with the clearColor and/or clearDepthStencil based on the attachments set up in the associated RenderPass. call after a framebuffer or window has been assigned to the RenderGraph.

## Member Data Documentation

## ◆ windowResizeHandler

ref_ptr<WindowResizeHandler> vsg::RenderGraph::windowResizeHandler

Callback used to automatically update viewports, scissors, renderArea and clears when the window is resized. By default resize handling is done.

The documentation for this class was generated from the following file:

- include/vsg/app/RenderGraph.h